<?
/* 
   This file is part of the 'Science Fair In A Box' project
   SFIAB Website: http://www.sfiab.ca

   Copyright (C) 2005 Sci-Tech Ontario Inc <info@scitechontario.org>
   Copyright (C) 2005 James Grant <james@lightbox.org>
   Copyright (C) 2007 David Grant <dave@lightbox.org>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation, version 2.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/
?>
<?
 require_once("common.inc.php");
 require_once("user.inc.php");
 user_auth_required();


 $u = user_load($_SESSION['users_id']);

 send_header("Main Page", array());

 //only display the named greeting if we have their name
 echo i18n("Hello <b>%1</b>",array($_SESSION['name']));
 echo "<br />";
 echo "<br />";

 echo "This is a placeholder for the main user page until all the specific user-role pages are removed.  For now, heres your roles: ";
 echo "<br />";
 echo "<br />";

 // get a list of all roles that this user can potentially sign up for
 $rlist = array();
 $q = mysql_query("SELECT * FROM roles");
 $available = array();
 $registered = array();
 while($row = mysql_fetch_assoc($q)){
 	$roleid = $row['type'];
 	$idx = $roleid . "_registration_type";
 	if(array_key_exists($idx, $config)){
 		// this is a role that can potentially be registered for
 		if(is_array($user['roles']) && array_key_exists($row['type'], $user['roles'])){
 			$registered[$row['type']] = $row['name'];
 		}else{
 			$available[$row['type']] = $row['name'];
 		}
 	}
 }

 if(count($registered) > 0){
 	echo "<h4>You are currently registered for the following roles:</h4>";
 	foreach($registered as $type => $title){
 		echo "$title<br/>";
 	}
 	echo "<br/>";
 }

 if(count($available) > 0){
 	echo "<h4>The following roles are available:</h4>";
 	foreach($available as $type => $title){
 		echo "$title<br/>";
 	}
 	echo "<br/>";
 }

 echo "<br />";
 echo i18n('Other Options and Things To Do').':<br />';
 echo '<ul>';
 echo '<li><a href="user_edit.php">'.i18n('Change Password').'</a> - '.i18n('Change your email, username, and password').'</li>';
 echo '<li><a href="user_edit.php">'.i18n('Activate/Deactivate Roles').'</a> - '.
		i18n('Activate/Deactiate/Remove/Delete roles or your entire account').
		'</li>';
 echo '<li>'.i18n('To logout, use the "Logout" link in the upper-right of the page').'</li>';
 echo '</ul>';

 send_footer();
